BSCUDPoints = BSCUDPoints or {}
local BSCUDP = BSCUDPoints

BSCUDP.Name = "BSCs-UltiPoints"
-- AddonInfo
BSCUDP.NameMenu = "BSCs-UltiPoints"
BSCUDP.NameSpaced = "BSCUltiPoints"
BSCUDP.Author = "@BloodStainChild666"
BSCUDP.SavedVar = "BSCUDPSaved"
BSCUDP.VersionDisplay = "2.0.5"

local ULT_INFO_PASSIVE_FRAGMENT = nil
local bAddPFrag = false
local ULT_INFO_POINTS_FRAGMENT = nil
local bAddUFrag = false
local ULT_INFO_BASE_FRAGMENT = nil
local bAddBFrag = false
local function AddFragment(fragment)
	SCENE_MANAGER:GetScene("hud"):AddFragment(fragment)
	SCENE_MANAGER:GetScene("hudui"):AddFragment(fragment)	
end
local function RemoveFragment(fragment)
	SCENE_MANAGER:GetScene("hud"):RemoveFragment(fragment)
	SCENE_MANAGER:GetScene("hudui"):RemoveFragment(fragment)	
end

local bDeath = false

local classid = 0

local CLASSID_DRAGONKNIGHT  = 1
local CLASSID_SORCERER		= 2
local CLASSID_NIGHTBLADE	= 3
local CLASSID_WARDEN		= 4
local CLASSID_NECROMANCER	= 5
local CLASSID_TEMPLAR		= 6
local CLASSID_ARCANIST		= 117

local allowedClassIds = {
    [CLASSID_DRAGONKNIGHT] = true,
    [CLASSID_NIGHTBLADE] = true,
    [CLASSID_WARDEN] = true,
    [CLASSID_NECROMANCER] = true,
    [CLASSID_ARCANIST] = true,
} 
local classid2Texture = {
    [CLASSID_DRAGONKNIGHT] = "esoui/art/icons/ability_dragonknight_024.dds",
    [CLASSID_NIGHTBLADE] = "esoui/art/icons/passive_sorcerer_002.dds",
    [CLASSID_WARDEN] = "esoui/art/icons/passive_warden_009.dds",
    [CLASSID_NECROMANCER] = "esoui/art/icons/passive_necromancer_011.dds",
    [CLASSID_ARCANIST] = "esoui/art/icons/passive_arcanist_08.dds",
}

local REGISTER_SKILLS = { 
	[29474] = true, -- DK
	[45005] = true, -- DK
	[36589] = true, -- NB
	[45146] = true, -- NB
	[88512] = true, -- Warden
	[88513] = true, -- Warden
	[120611] = true, -- Necro
	[120612] = true, -- necro
	[185070] = true, -- Arc
	[185051] = true, -- Arc
} 

local bAddonActive = false
local SLOTTED_SKILLS = { 
	-- DK
	[31820] = true,
	[31874] = true,
	[29224] = true,	
	[32685] = true,	
	[20779] = true,
	-- NB
	[34838] = true,
	[34721] = true,
	[36943] = true,	
	[36908] = true,	
	[36901] = true,
	[35508] = true,	
	-- Wardn
	[85999] = true,
	[86019] = true,
	[86027] = true,	
	[86054] = true,	
	[86041] = true,
	-- Necro
	[117805] = true,
	[118763] = true,	
	[118623] = true,
	[117883] = true,
	[118017] = true,
	[118070] = true,
	[118367] = true,
}
local HOTBAR_CATEGORY_SET =
{
    [HOTBAR_CATEGORY_PRIMARY] = true,
    [HOTBAR_CATEGORY_BACKUP] = true,
    [HOTBAR_CATEGORY_OVERLOAD] = false,
    [HOTBAR_CATEGORY_WEREWOLF] = false,
    [HOTBAR_CATEGORY_TEMPORARY] = false,
    [HOTBAR_CATEGORY_DAEDRIC_ARTIFACT] = false,
    [HOTBAR_CATEGORY_COMPANION] = false,
}
-- ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
local defaultSV_ACC = {	
	-- passive UI 
	UI_LEFT 		= -250,
	UI_TOP  		= 0,
	UI_ALPHA 		= 1,
	UI_ENABLE		= true,
	UI_LOCK 		= false,	
	UI_ALLWAYS		= true,
	-- ult points UI
	UI_LEFT_UP 		= 0,
	UI_TOP_UP  		= 80,
	UI_ALPHA_UP 	= 1,
	UI_ENABLE_UP 	= true,
	UI_HOTBAR_UP 	= -1,
	UI_LOCK_UP 		= false,
	--
	UI_FONT = "BOLD_FONT",
	UI_FONT_STYLE = "soft-shadow-thick", 
	UI_FONT_COLOR_N = {0, 255, 0, 255},
	UI_FONT_COLOR_C = {255, 0, 0, 255},
	FONT_SIZE = 28,
	--Base Reg UI
	UI_LEFT_BASE 	= 80,
	UI_TOP_BASE  	= 80,
	UI_ALPHA_BASE 	= 1,
	UI_ENABLE_BASE	= false,
	UI_LOCK_BASE	= false,
	UI_ALLWAYS_BASE = true,
}
-------------------------------------------------------------------------------------------------
--
-------------------------------------------------------------------------------------------------
local function UpdateUltimateUI()	
	if not BSCUDP.SV_ACC.UI_ENABLE_UP then return end
	local choosenhotbar = GetActiveHotbarCategory()
	if BSCUDP.SV_ACC.UI_HOTBAR_UP ~= -1 then
		choosenhotbar = BSCUDP.SV_ACC.UI_HOTBAR_UP
	end
	local need_utl = GetSlotAbilityCost(ACTION_BAR_ULTIMATE_SLOT_INDEX + 1, COMBAT_MECHANIC_FLAGS_ULTIMATE, choosenhotbar)
	local current_ult = GetUnitPower('player', POWERTYPE_ULTIMATE)
	if current_ult > need_utl then
		BSCUDULTPointsUI:GetNamedChild("lblUlti"):SetColor(unpack(BSCUDP.SV_ACC.UI_FONT_COLOR_N))
	else
		BSCUDULTPointsUI:GetNamedChild("lblUlti"):SetColor(unpack(BSCUDP.SV_ACC.UI_FONT_COLOR_C))
	end
	BSCUDULTPointsUI:GetNamedChild("lblUlti"):SetText(current_ult)
end
-------------------------------------------------------------------------------------------------
--
-------------------------------------------------------------------------------------------------
--MorphSlot
--    MORPH_SLOT_BASE
--    MORPH_SLOT_MORPH_1
--    MORPH_SLOT_MORPH_2 
local bCheckHotbar = false
local function CheckHotbar()
	if not bAddonActive then return end
	if not bCheckHotbar then return end
	local bSkillExist = false
	for hotbarCategory in pairs(HOTBAR_CATEGORY_SET) do
		if HOTBAR_CATEGORY_SET[hotbarCategory] then
			local hotbar = ACTION_BAR_ASSIGNMENT_MANAGER:GetHotbar(hotbarCategory)
			if hotbar ~= nil then 
				 for actionSlotIndex, slotData in hotbar:SlotIterator() do
					if slotData:IsStillValid() then
						local skilldata = slotData:GetPlayerSkillData()
						if skilldata ~= nil then
							if skilldata:IsActive() then
								local skillType, skillLineIndex, skillIndex = skilldata:GetIndices()								
								local abilityId, lineRankNeededToUnlock = GetSpecificSkillAbilityInfo(skillType, skillLineIndex, skillIndex, MORPH_SLOT_MORPH_1, 1)
								if SLOTTED_SKILLS[abilityId] ~= nil then
									bSkillExist = true
								end
							end
						end
					end
				 end
			end
		end
	end
	if bSkillExist then
		if not bAddPFrag then 
			AddFragment(ULT_INFO_PASSIVE_FRAGMENT) 
			bAddPFrag = true
		end
	else
		if bAddPFrag then 
			RemoveFragment(ULT_INFO_PASSIVE_FRAGMENT) 
			bAddPFrag = false
		end
	end
	UpdateUltimateUI()
end
-- ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-- ult gain
-------------------------------------------------------------------------------------------------
local BuffStartTime = 0
local function OnCombatEvent( _, result, _, _, _, _, sourceName, sourceType, targetName, targetType, hitValue, powerType, damageType, log, sourceUnitId, targetUnitId, abilityId, overflow )
	if hitValue <= 0 then return end
	if REGISTER_SKILLS[abilityId] ~= nil then
		BuffStartTime = (GetGameTimeMilliseconds() + GetAbilityCooldown(abilityId, 'player')) / 1000
	end	
end

local bCombat = false
local function OnCombatState(_, inCombat)	
	bCombat = inCombat
end
local ACTION_SLOT_TYPE =
{
	[ACTION_SLOT_TYPE_HEAVY_ATTACK] = true,
	[ACTION_SLOT_TYPE_LIGHT_ATTACK] = true,
}
local BaseStartTime = 0
local function OnCombatEventULTBASE( _, result, _, _, _, abilityActionSlotType, sourceName, sourceType, targetName, targetType, hitValue, powerType, damageType, log, sourceUnitId, targetUnitId, abilityId, overflow )
	if result == ACTION_RESULT_DODGED or result == ACTION_RESULT_BLOCKED_DAMAGE then
		BaseStartTime = GetGameTimeSeconds() + 8
	end
	if not bCombat then return end
	if ACTION_SLOT_TYPE[abilityActionSlotType] then
		BaseStartTime = GetGameTimeSeconds() + 8
	end	
end
-------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------
local function UpdateUI()
	if BSCUDP.SV_ACC.UI_ENABLE then
		local DURATION = BuffStartTime - GetGameTimeSeconds()
		if DURATION <= 0 then 
			DURATION = 0 
		end			
		local LB = BSCUDPointsUI:GetNamedChild("Info")
		local BF = BSCUDPointsUI:GetNamedChild("FrameBack")
		LB:SetText(string.format("%.0f", DURATION))		
		if DURATION == 0 then
			LB:SetColor(0, 1, 0, 1)	
			BF:SetCenterColor(0, 1, 0, 1)
		elseif DURATION < 3 then
			LB:SetColor(0.8, 1, 0, 1)
			BF:SetCenterColor(0.8, 1, 0, 1)
			if BSCUDP.SV_ACC.UI_ALLWAYS then
				BSCUDPointsUI:SetHidden(false)
			end
		else		
			LB:SetColor(1, 0, 0, 1)
			BF:SetCenterColor(1, 0, 0, 1)
			if BSCUDP.SV_ACC.UI_ALLWAYS then
				BSCUDPointsUI:SetHidden(true)
			end
		end
	end
	if BSCUDP.SV_ACC.UI_ENABLE_BASE then
		local DURATION = BaseStartTime - GetGameTimeSeconds()
		if DURATION <= 0 then 
			DURATION = 0 
		end			
		local LB = BSCUDPointsUIBASE:GetNamedChild("Info")
		local BF = BSCUDPointsUIBASE:GetNamedChild("FrameBack")
		LB:SetText(string.format("%.0f", DURATION))		
		if DURATION == 0 then
			LB:SetColor(0, 1, 0, 1)	
			BF:SetCenterColor(0, 1, 0, 1)
		elseif DURATION < 3 then
			LB:SetColor(0.8, 1, 0, 1)
			BF:SetCenterColor(0.8, 1, 0, 1)
			if BSCUDP.SV_ACC.UI_ALLWAYS_BASE then
				BSCUDPointsUIBASE:SetHidden(false)
			end
		else
			LB:SetColor(1, 0, 0, 1)
			BF:SetCenterColor(1, 0, 0, 1)
			if BSCUDP.SV_ACC.UI_ALLWAYS_BASE then
				BSCUDPointsUIBASE:SetHidden(true)
			end
		end
	end
end
-- ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function BSCUDP:OnMoveStop()
	BSCUDP.SV_ACC.UI_LEFT = BSCUDPointsUI:GetLeft()
	BSCUDP.SV_ACC.UI_TOP = BSCUDPointsUI:GetTop()
	BSCUDP.SV_ACC.UI_LEFT_UP = BSCUDULTPointsUI:GetLeft()
	BSCUDP.SV_ACC.UI_TOP_UP = BSCUDULTPointsUI:GetTop()	
	BSCUDP.SV_ACC.UI_LEFT_BASE = BSCUDPointsUIBASE:GetLeft()
	BSCUDP.SV_ACC.UI_TOP_BASE = BSCUDPointsUIBASE:GetTop()	
end
-- ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function BSCUDP:SetPosition()
	if BSCUDP.SV_ACC.UI_LEFT ~= -250 and BSCUDP.SV_ACC.UI_TOP ~= 0 then
		BSCUDPointsUI:ClearAnchors()
		BSCUDPointsUI:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, BSCUDP.SV_ACC.UI_LEFT, BSCUDP.SV_ACC.UI_TOP)
	end
	BSCUDPointsUI:SetAlpha(BSCUDP.SV_ACC.UI_ALPHA)
	
	if BSCUDP.SV_ACC.UI_LEFT_UP ~= 0 and BSCUDP.SV_ACC.UI_TOP_UP ~= 80 then
		BSCUDULTPointsUI:ClearAnchors()
		BSCUDULTPointsUI:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, BSCUDP.SV_ACC.UI_LEFT_UP, BSCUDP.SV_ACC.UI_TOP_UP)
	end
	BSCUDULTPointsUI:SetAlpha(BSCUDP.SV_ACC.UI_ALPHA_UP)
	
	
	if BSCUDP.SV_ACC.UI_LEFT_BASE ~= 80 and BSCUDP.SV_ACC.UI_TOP_BASE ~= 80 then
		BSCUDPointsUIBASE:ClearAnchors()
		BSCUDPointsUIBASE:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, BSCUDP.SV_ACC.UI_LEFT_BASE, BSCUDP.SV_ACC.UI_TOP_BASE)
	end
	BSCUDPointsUIBASE:SetAlpha(BSCUDP.SV_ACC.UI_ALPHA_BASE)
end
-- ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
local function DeathRecapAddUltiPoints()
	BSCUDP.UltiLabel:SetHidden(false)
	BSCUDP.UltiLabel:SetText("Ultimate Points: " .. GetUnitPower('player', POWERTYPE_ULTIMATE))
end
local function CreateLable()
	-- font
	local fontSize = 23
	local font = string.format("$(BOLD_FONT)|$(KB_%s)|soft-shadow-thick", fontSize)		
	local parent = ZO_Death		
	BSCUDP.UltiLabel = WINDOW_MANAGER:CreateControl(nil, parent, CT_LABEL)
	BSCUDP.UltiLabel:SetAnchor(BOTTOM, parent, TOP, 0, 0) 
	BSCUDP.UltiLabel:SetFont(font)
end
function BSCUDP:UpdatePassiveUI()
	if allowedClassIds[classid] and BSCUDP.SV_ACC.UI_ENABLE then
		if not bAddonActive then
			bCheckHotbar = true
			EVENT_MANAGER:RegisterForEvent(BSCUDP.Name, EVENT_ACTION_SLOTS_ALL_HOTBARS_UPDATED, function() CheckHotbar() end)	
				BSCUDPointsUI:GetNamedChild("Icon"):SetTexture(classid2Texture[classid] or "")
			if classid == CLASSID_ARCANIST then
				bCheckHotbar = false
			end
			if not bAddPFrag then
				AddFragment(ULT_INFO_PASSIVE_FRAGMENT)
				bAddPFrag = true
			end
			bAddonActive = true
		end
	else
		if bAddonActive then
			EVENT_MANAGER:UnregisterForEvent(BSCUDP.Name, EVENT_ACTION_SLOTS_ALL_HOTBARS_UPDATED)
			RemoveFragment(ULT_INFO_PASSIVE_FRAGMENT)
			BSCUDPointsUI:SetHidden(true)
			bAddPFrag = false 
			bAddonActive = false
			bCheckHotbar = false
		end
	end	
end
function BSCUDP:UpdateEnableUP()
	if BSCUDP.SV_ACC.UI_ENABLE_UP then
		AddFragment(ULT_INFO_POINTS_FRAGMENT)
		bAddUFrag = true
	else
		RemoveFragment(ULT_INFO_POINTS_FRAGMENT)
		bAddUFrag = false
	end
end
function BSCUDP:UpdateEnableBase()
	if BSCUDP.SV_ACC.UI_ENABLE_BASE then
		AddFragment(ULT_INFO_BASE_FRAGMENT)
		bAddBFrag = true
	else
		RemoveFragment(ULT_INFO_BASE_FRAGMENT)
		bAddBFrag = false
	end
end
function BSCUDP:FontCheck(size)
    local thresholds = {54, 48, 40, 36, 34, 32, 30, 28, 26}
    for _, threshold in ipairs(thresholds) do
        if size > threshold then
            return threshold
        end
    end
    return size
end
function BSCUDP:UpdateSettings()
	BSCUDPointsUI:SetMovable(not BSCUDP.SV_ACC.UI_LOCK)
	BSCUDPointsUI:SetAlpha(BSCUDP.SV_ACC.UI_ALPHA)	
	BSCUDULTPointsUI:SetMovable(not BSCUDP.SV_ACC.UI_LOCK_UP)
	BSCUDULTPointsUI:SetAlpha(BSCUDP.SV_ACC.UI_ALPHA_UP)
	BSCUDULTPointsUI:GetNamedChild("lblUlti"):SetFont("$("..BSCUDP.SV_ACC.UI_FONT..")|$(KB_".. BSCUDP:FontCheck(BSCUDP.SV_ACC.FONT_SIZE)..")|"..BSCUDP.SV_ACC.UI_FONT_STYLE)
	BSCUDPointsUIBASE:SetMovable(not BSCUDP.SV_ACC.UI_LOCK_BASE)
	BSCUDPointsUIBASE:SetAlpha(BSCUDP.SV_ACC.UI_ALPHA_BASE)
	UpdateUltimateUI()
end
local function OnActionSlotsFullUpdate(_, isHotbarSwap)
	if isHotbarSwap then
		UpdateUltimateUI()
	end
end
local function OnPlayerActivated()		
	CheckHotbar()
	UpdateUltimateUI()	
end
local ULT_GAIN_BASE_FILTERS = {
	[ACTION_RESULT_DAMAGE] = REGISTER_FILTER_SOURCE_COMBAT_UNIT_TYPE,
	[ACTION_RESULT_CRITICAL_DAMAGE] = REGISTER_FILTER_SOURCE_COMBAT_UNIT_TYPE,
	[ACTION_RESULT_DAMAGE_SHIELDED] = REGISTER_FILTER_SOURCE_COMBAT_UNIT_TYPE,
	[ACTION_RESULT_BLOCKED_DAMAGE] = REGISTER_FILTER_TARGET_COMBAT_UNIT_TYPE,
	[ACTION_RESULT_DODGED] = REGISTER_FILTER_TARGET_COMBAT_UNIT_TYPE,
}

function BSCUDP.init(event, addonName)	
	if addonName ~= BSCUDP.Name then
		return 
	end	
	EVENT_MANAGER:UnregisterForEvent(BSCUDP.Name, EVENT_ADD_ON_LOADED)
	
	BSCUDP.SV_ACC = ZO_SavedVars:NewAccountWide(BSCUDP.SavedVar, 1, nil, defaultSV_ACC)	
	CreateLable()
	classid = GetUnitClassId('player') 
		
	-- Create UI Fragments
	ULT_INFO_PASSIVE_FRAGMENT = ZO_HUDFadeSceneFragment:New(BSCUDPointsUI)
	ULT_INFO_POINTS_FRAGMENT = ZO_HUDFadeSceneFragment:New(BSCUDULTPointsUI)
	ULT_INFO_BASE_FRAGMENT = ZO_HUDFadeSceneFragment:New(BSCUDPointsUIBASE)
			
	EVENT_MANAGER:RegisterForEvent(BSCUDP.Name, EVENT_PLAYER_ACTIVATED, OnPlayerActivated)
	
	EVENT_MANAGER:RegisterForEvent(BSCUDP.Name, EVENT_PLAYER_DEAD, function(...) DeathRecapAddUltiPoints() bDeath = true end)	
	EVENT_MANAGER:RegisterForEvent(BSCUDP.Name, EVENT_PLAYER_ALIVE, function(...) BSCUDP.UltiLabel:SetHidden(true) bDeath = false end)
	EVENT_MANAGER:RegisterForEvent(BSCUDP.Name, EVENT_POWER_UPDATE, function(...) 
		-- Updaet Movable UI	
		UpdateUltimateUI()
		if bDeath then 
			DeathRecapAddUltiPoints() 
		end 
	end)
	EVENT_MANAGER:AddFilterForEvent(BSCUDP.Name, EVENT_POWER_UPDATE, REGISTER_FILTER_POWER_TYPE, POWERTYPE_ULTIMATE)
	EVENT_MANAGER:RegisterForEvent(BSCUDP.Name, EVENT_ACTION_SLOTS_FULL_UPDATE, OnActionSlotsFullUpdate)	
	
	-- for ult gain
	EVENT_MANAGER:RegisterForEvent(BSCUDP.Name, EVENT_COMBAT_EVENT, OnCombatEvent)	
	EVENT_MANAGER:AddFilterForEvent(BSCUDP.Name, EVENT_COMBAT_EVENT, REGISTER_FILTER_COMBAT_RESULT, ACTION_RESULT_POWER_ENERGIZE)
	EVENT_MANAGER:AddFilterForEvent(BSCUDP.Name, EVENT_COMBAT_EVENT, REGISTER_FILTER_POWER_TYPE, POWERTYPE_ULTIMATE)
	EVENT_MANAGER:AddFilterForEvent(BSCUDP.Name, EVENT_COMBAT_EVENT, REGISTER_FILTER_TARGET_COMBAT_UNIT_TYPE, COMBAT_UNIT_TYPE_PLAYER)
		
	-- Ult gain basic LA/HA/BLOCK/ROLL
	local nCount = 1
	for FILTER, TYPE in pairs(ULT_GAIN_BASE_FILTERS) do	
		local eventName = BSCUDP.Name..'ULTACTION_'..nCount	
		EVENT_MANAGER:RegisterForEvent(eventName, EVENT_COMBAT_EVENT, OnCombatEventULTBASE)	
		EVENT_MANAGER:AddFilterForEvent(eventName, EVENT_COMBAT_EVENT, REGISTER_FILTER_COMBAT_RESULT, FILTER, TYPE, COMBAT_UNIT_TYPE_PLAYER)
		nCount = nCount + 1
	end	
	--
	EVENT_MANAGER:RegisterForEvent(BSCUDP.Name, EVENT_PLAYER_COMBAT_STATE, 	OnCombatState)	
		
	EVENT_MANAGER:RegisterForUpdate(BSCUDP.Name, 200, UpdateUI)	

	BSCUDP:InitMenu()
	BSCUDP:UpdateEnableUP()
	BSCUDP:UpdatePassiveUI()
	BSCUDP:UpdateEnableBase()
	BSCUDP:UpdateSettings()
	BSCUDP:SetPosition()
end

EVENT_MANAGER:RegisterForEvent(BSCUDP.Name, EVENT_ADD_ON_LOADED, BSCUDP.init)